﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;

namespace MessageDiagnosticsInterceptors
{
    public class CustomServiceHost : ServiceHost
    {
        protected CustomServiceHost()
        {
        }

        public CustomServiceHost( Type serviceType, params Uri[] baseAddresses ) : base( serviceType, baseAddresses )
        {
        }

        public CustomServiceHost( object singletonInstance, params Uri[] baseAddresses ) : base( singletonInstance, baseAddresses )
        {
        }

        protected override void OnOpening()
        {
            Description.Behaviors.Add( new MessageDiagnosticsServiceBehavior() );

            base.OnOpening();
        }
    }
}
