﻿using System.Collections.ObjectModel;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;

namespace MessageDiagnosticsInterceptors
{
    public class MessageDiagnosticsServiceBehavior : IServiceBehavior
    {
        public void Validate( ServiceDescription serviceDescription, ServiceHostBase serviceHostBase )
        {

        }

        public void AddBindingParameters( ServiceDescription serviceDescription, ServiceHostBase serviceHostBase, Collection<ServiceEndpoint> endpoints, BindingParameterCollection bindingParameters )
        {
            return;
        }

        public void ApplyDispatchBehavior( ServiceDescription serviceDescription, ServiceHostBase serviceHostBase )
        {
            foreach ( ChannelDispatcher chDisp in serviceHostBase.ChannelDispatchers )
            {
                foreach ( EndpointDispatcher epDisp in chDisp.Endpoints )
                {
                    epDisp.DispatchRuntime.MessageInspectors.Add( new MessageDiagnosticsInterceptor() );
                }
            }
        }
    }
}